require "./lib/menu/lista.rb"
Nodo = Struct.new(:value, :next, :prev)
class DoubleList < Lista
    include Enumerable
    attr_accessor :tail
    def initialize(nodo)
        @head = nodo
        @size = 1
        @tail = nodo  
        @head.prev = nil  
    end
    def insert(dieta)
       nodo = Nodo.new(dieta, nil, @tail)
       @tail.next = nodo
       @tail = nodo
       @size = @size + 1     
    end
    
    def each
        i=1
        siguiente = @head
        while i <= @size do
           yield(siguiente.value)
            siguiente = siguiente.next
            i = i + 1
        end 
    end
    
    def extraerHead
       nodo = @head
       @head = @head.next
       @head.prev = nil
       @size = @size - 1
       nodo.value
    end
    

end

